	include "doorsos.h"
	include "graphlib.h"
    include "userlib.h"
	xdef	_library
	xdef    _ti89
	xdef    _ti92plus
        xdef    passlib@0000   ; inputstr       ;OK
        xdef    passlib@0001   ; getpassword    ;OK
        xdef    passlib@0002   ; changepass     ;OK
        xdef    passlib@0003   ; lockcalc       ;OK
        xdef    passlib@0004   ; idle_hot       ;OK
        xdef    passlib@0005   ; memo           ;OK
        xdef    passlib@0006   ; bolt           ;OK

idle_loop:
	movem.l	a0-a6/d1-d7,-(a7)
    jsr     userlib::idle_loop
	movem.l	(a7)+,a0-a6/d1-d7
	rts

passlib@0004:
idle_hot:
\again	bsr	idle_loop
	tst.b	CALCULATOR
	beq	\hot89
	cmp.w   #274,d0  ;F7 ==> lock
	bne     \275
	bsr     lockcalc
	bra	\again
\275	cmp.w   #275,d0  ;F8 ==> shut
	bne	\fin
	trap    #4
	bra	\again
\fin	rts
\hot89	cmp.w   #277,d0  ;Home ==> lock
	bne     \266
	bsr     lockcalc
	bra	\again
\266	cmp.w   #266,d0  ;Mode ==> shut
	bne	\fin
	trap    #4
	bra	\again

passlib@0003
lockcalc:
;sauve l'ecran
	movem.l	d0-d7/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#LCD_LINE_BYTES,d2
	move.w		#LCD_HEIGHT,d3
	jsr		graphlib::scrtomem
;eteint la caltos
shut:
    jsr graphlib::clr_scr     ;Clears screen
	trap		#4

	bsr		getpassword
	tst.l		d1
	bne		shut
	clr.w		d1
	tst.w		d4
	beq		\fin
	move.w		#LCD_HEIGHT,d3
	jsr		graphlib::memtoscr
\fin	movem.l	(a7)+,d0-d7/a0-a6
	rts


passlib@0000
InputStr:
;       d1.w : X
;       d2.w : Y
;       d3.w : Maxchar
;output:  d0 = nbchars  0 si on presse echap
	move.l	d6,-(a7)
	moveq.l	#1,d6
	bsr		Input
	move.l	(a7)+,d6
	rts

Input:
;d1=x ; d2 = y ; d3  = maxchar ; d6 = 0 -> mettre des *
	movem.l	 d1-d7/a1,-(a7)
	move.b		doorsos::MaxHandles+$24+$11,d7	;sauve le mode alphanum
	move.b		#1,doorsos::MaxHandles+$24+$11

\OK  	lea	temp1,a0
	move.w  d3,d5
	subq    #1,d5
	lsl.w   #3,d5 ; nb de char * 8
	move.l  a0,a1
\retclear clr.w   d4
\retour    move.b  #124,(a0)       ;the '|' char
	clr.b   1(a0)
\WaitKey bsr	Print_Txt
	tst.w	d6
	beq	\@1
	bsr	idle_hot
	bra	\@2
\@1	bsr	idle_loop
\@2	cmp.w	#13,d0			; Enter ?
	beq	\enter
	cmp.w   #263,d0
	beq     \clear
	cmp.w   #257,d0                 ; Backspace ?
	beq     \BackSp
	cmp.w   #264,d0                 ;ESC ?
	beq     \ESC
	cmp.w   #255,d0         ;Valid character ?
	bhi     \WaitKey        ;no => loop
	cmp.w   d3,d4           ;Maxchar ?
	beq     \WaitKey
	move.b  d0,(a0)+
	addq.w  #1,d4
	bra	\retour
\clear  move.l  a1,a0
	bra		\retclear
\BackSp tst.w	d4
	beq		\WaitKey
	subq.w	#1,d4
	tst.b		-(a0)
	bra		\retour
\enter clr.b	(a0)
	bsr		Print_Txt
	move.w	d4,d0
	bra		\end
\ESC	clr.w		d0
\end	lea		temp1,a0

	move.b		d7,doorsos::MaxHandles+$24+$11

	movem.l (a7)+,d1-d7/a1
	rts
Print_Txt:
        movem.l d0-d7/a0-a6,-(a7)
        move.w  d1,d0
        move.w  d2,d1
        move.w  d5,d2
        moveq.w  #7,d3
        moveq.w  #1,d4
        jsr     graphlib::fill
	tst.w	d6
	beq	dispstars
	bra	Write2
Write: movem.l	d0-d7/a0-a6,-(a7)
Write2: move.w	#4,-(a7)		;Color
	move.l	a1,-(a7)                ;address
	move.w	d1,-(a7)		;Y
	move.w	d0,-(a7)		;X
        jsr             doorsos::DrawStrXY         ;Print !
	lea		10(a7),a7		
	movem.l	(a7)+,d0-d7/a0-a6
	rts
printf: movem.l	d0-d7/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.b	(a1)+,d0
	move.b	(a1)+,d1
	bra		Write2

dispstars:
	move.l	16(a7),d4
	lea		stars(pc),a1
\affstar tst.w	d4
	beq		\disped
	bsr		Write
	addq.w	#6,d0
	dbra		d4,\affstar
\disped movem.l	(a7)+,d0-d7/a0-a6
	rts

passlib@0001
;getpassword:
;    movem.l    d0/d2-d7/a0-a6,-(a7)
;    lea        mespass(pc),a0    ; title of the box
;    jsr        graphlib::smallbox    ; display the box
;
;    clr.w        -(a7)
;    jsr        doorsos::FontSetSys    ; Font #0
;    addq.l        #2,a7
;
;    lea        tit1pass(pc),a1    ; a1 = 92+ string
;    tst.b        CALCULATOR        ; 89 or 92+ ?
;    bne        \OK92            ; -> 92+
;    lea        s89_tit1pass(pc),a1    ; a1 = 89 string
;\OK92    bsr        printf            ; display the string (a1)
;getpword:
;    bclr.b        #2,$600001        ; mem protection off
;    move.l        $78,d5            ; saves the old auto int 6 handler
;    move.l        #ONKEY,$78        ; installs my auto int 6 handler
;    jsr        userlib::get_APD
;    move.w        d0,d7            ; saves the APD counter
;    moveq.w    #5,d0
;    jsr        userlib::set_APD        ; set the APD value to 5 seconds
;    moveq.w    #63,d1            ; x (for 92+)
;    moveq.w    #59,d2            ; y (for 92+)
;    moveq.w    #10,d3            ; max char
;    tst.b        CALCULATOR        ; 89 or 92+ ?
;    bne        \OK92            ; 92+
;    moveq.w    #50,d1            ; x (for 89)
;    moveq.w    #48,d2            ; y (for 89)
;\OK92    clr.w        d6            ; it is a password input
;    bsr        Input            ; Input the password
;    move.w     d0,d1
;    move.l        d5,$78            ; restores the auto int 6 handler
;    bset.b        #2,$600001        ; mem protection off
;    move.w        d7,d0
;    jsr        userlib::set_APD        ; restores the APD counter value
;
;    movem.L    d0-d2/a0-a1,-(a7)    ; saves some regs
;    movem.l    (a7)+,d0-d2/a0-a1
;
;    tst.w	d0            ; any password entered ?
;    beq        wrong            ; no -> pass is wrong
;    lea        pword(pc),a1        ; a1 points to the correct password
;    bsr        strcomp        ; compares (a0) and (a1) strings, result in d1.w
;wrong:    movem.l    (a7)+,d0/d2-d7/a0-a6
;    rts
;
; AUTO INT 6 handler for the password input functions
;ONKEY:    rte            ; just returns =)

getpassword:
	movem.l	d0/d2-d7/a0-a6,-(a7)
	lea	mespass(pc),a0    ; title of the box
	jsr	graphlib::smallbox    ; display the box

	clr.w	-(a7)
	jsr	doorsos::FontSetSys    ; Font #0
	addq.l	#2,a7

	move.w	d0,a5            ; save d0 ( = old font) into a5
	lea	tit1pass(pc),a1    ; a1 = 92+ string
	tst.b	CALCULATOR        ; 89 or 92+ ?
	bne	\OK92            ; -> 92+
	lea	s89_tit1pass(pc),a1    ; a1 = 89 string
\OK92
	bsr	printf            ; display the string (a1)
getpword:
	move.l        $78,d5            ; saves the old auto int 6 handler
	move.l        #ONKEY,$40078        ; installs my auto int 6 handler

    jsr        userlib::get_APD
	move.w        d0,d7            ; saves the APD counter

	moveq.w    #5,d0
    jsr        userlib::set_APD        ; set the APD value to 5 seconds

	moveq.w    #63,d1            ; x (for 92+)
	moveq.w    #59,d2            ; y (for 92+)
	moveq.w    #10,d3            ; max char
	tst.b        CALCULATOR        ; 89 or 92+ ?
	bne        \OK92            ; 92+
	moveq.w    #50,d1            ; x (for 89)
	moveq.w    #48,d2            ; y (for 89)
\OK92
	clr.w        d6            ; it is a password input
	bsr        Input            ; Input the password
	move.w     d0,d1
	move.l        d5,$40078            ; restores the auto int 6 handler
	move.w        d7,d0
    jsr        userlib::set_APD

    movem.L    d0-d2/a0-a1,-(a7)    ; saves some regs    
    movem.l    (a7)+,d0-d2/a0-a1

    tst.w	d0            ; any password entered ?
    beq        wrong            ; no -> pass is wrong
    lea        pword(pc),a1        ; a1 points to the correct password
    bsr        strcomp        ; compares (a0) and (a1) strings, result in d1.w
wrong:    movem.l    (a7)+,d0/d2-d7/a0-a6
    rts

; AUTO INT 6 handler for the password input functions
ONKEY:    rte            ; just returns =)

passlib@0002
changepass:
;sauve l'ecran
	movem.l	d0-d7/a0-a6,-(a7)
	clr.w		d0
	clr.w		d1
	move.w		#LCD_LINE_BYTES,d2
	move.w		#LCD_HEIGHT,d3
	jsr		graphlib::scrtomem

\debut
	bsr             getpassword
	tst             d1
	bne             \exit         ;si mauvais pass => retourne
;obtenir le nveau pass
	lea		(npword+2)(pc),a0
	jsr		graphlib::smallbox

	clr.w		-(a7)
	jsr		doorsos::FontSetSys
	addq.l		#2,a7
	lea		npword(pc),a1
	moveq.w	#59,d2
	moveq.w	#63,d1
	tst.b		CALCULATOR
	bne		\OK92
	lea		s89_npword(pc),a1
	moveq.w	#48,d2
	moveq.w	#50,d1
\OK92	bsr		\smallbsr	;demande le pass

	lea		temppass,a2
	move.l		a2,a3
\cpy	move.b		(a0)+,(a3)+	;copie le pass obtenu
	dbra		d0,\cpy

;demande la confirmation
	lea		confirm(pc),a1
	moveq.w	#84,d2
	moveq.w	#63,d1
	tst.b		CALCULATOR
	bne		\OK92i
	lea		s89_confirm(pc),a1
	moveq.w	#70,d2
	moveq.w	#50,d1
\OK92i	bsr		\smallbsr
	move.l		a2,a1
	bsr		strcomp
	tst.w		d1
	beq		\okconfirm
; si la confirmation est differente
	pea		badconf(pc)
	jsr		doorsos::ST_showHelp
	addq.l		#4,a7
	bra		\debut
\okconfirm
	lea		pword(pc),a1
\copy	move.b		(a0)+,(a1)+
	dbra		d0,\copy
\exit
        move.w          0,d0
	clr.w		d1
	tst.w		d4
	beq		\fin
	clr.w		d0
	clr.w		d1
	move.w		#LCD_LINE_BYTES,d2
	move.w		#LCD_HEIGHT,d3
	jsr		graphlib::memtoscr
        clr.w           d2
\fin	movem.l	(a7)+,d0-d7/a0-a6
	rts

\smallbsr
	bsr		printf
	moveq.w	#10,d3
	clr.w		d6
	bsr		Input
	tst.w		d0
	bne		\OK
	addq.l		#4,a7
	bra		\exit
\OK	rts


strcomp:
;a0 et a1 chaine a comparer 
	movem.l	d0/d2/a0-a1,-(a7)
	movem.l	a0/a1,-(a7)
	jsr		doorsos::strcmp
	addq.l		#8,a7
	move.w		d0,d1
	movem.l	(a7)+,d0/d2/a0-a1
	rts

passlib@0005:
memo          dc.w 0
 rts

passlib@0006:
bolt          dc.w 3
 rts
;*****************************************************
; Program data
;*****************************************************

char	dc.b	0,0
stars		dc.b "*",0
pword           dc.b "flash",0,0,0,0,0,0
npword          dc.b 53,44,"Enter the new PassWord:",0
tit1pass        dc.b 53,44,"Enter the current PassWord:",0
mespass dc.b "PassWord Protection",0
confirm dc.b 53,71,"Confirm the PassWord:",0
badconf	dc.b "Password confirmation failed",0

s89_npword      dc.b 40,38,"Enter the new PassWord:",0
s89_tit1pass    dc.b 32,38,"Enter the current PassWord:",0
s89_confirm     dc.b 40,60,"Confirm the PassWord:",0

	BSS
temppass	ds.b	11
temp1           dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
nbitem	dc.w 0
Xmes    dc.w 0
Ymes    dc.w 0
nblim   dc.w 0
nbinc   dc.w 0
Font	dc.w 0

	end
